Ruby: pm_instance_variable_write_node Struct Reference

Ruby 3.4.8p72 (2025-12-17 revision 995b59f66677d44767ce9faac6957e5543617ff9)

Data Fields
pm_instance_variable_write_node Struct Reference

InstanceVariableWriteNode. More...

`#include <ast.h>`

## Data Fields
pm_node_t | base
| The embedded base node.
pm_constant_id_t | name
| InstanceVariableWriteNode::name.
pm_location_t | name_loc
| InstanceVariableWriteNode::name_loc.
struct pm_node * | value
| InstanceVariableWriteNode::value.
pm_location_t | operator_loc
| InstanceVariableWriteNode::operator_loc.
Data Fields inherited from pm_node
pm_node_type_t | type
| This represents the type of the node.
pm_node_flags_t | flags
| This represents any flags on the node.
uint32_t | node_id
| The unique identifier for this node, which is deterministic based on the source.
pm_location_t | location
| This is the location of the node in the source.

## Detailed Description

InstanceVariableWriteNode.

Represents writing to an instance variable.

    @foo = 1
    ^^^^^^^^

Type: PM_INSTANCE_VARIABLE_WRITE_NODE

Definition at line 5144 of file ast.h.

## Field Documentation

## ◆ base

pm_node_t pm_instance_variable_write_node::base

The embedded base node.

Definition at line 5146 of file ast.h.

Referenced by pm_dump_json().

## ◆ name

pm_constant_id_t pm_instance_variable_write_node::name

InstanceVariableWriteNode::name.

The name of the instance variable, which is a `@` followed by an identifier.

    @x = :y       # name `:@x`

    @_foo = "bar" # name `@_foo`

Definition at line 5158 of file ast.h.

Referenced by pm_dump_json().

## ◆ name_loc

pm_location_t pm_instance_variable_write_node::name_loc

InstanceVariableWriteNode::name_loc.

The location of the variable name.

    @_x = 1
    ^^^

Definition at line 5168 of file ast.h.

Referenced by pm_dump_json().

## ◆ operator_loc

pm_location_t pm_instance_variable_write_node::operator_loc

InstanceVariableWriteNode::operator_loc.

The location of the `=` operator.

    @x = y
       ^

Definition at line 5191 of file ast.h.

Referenced by pm_dump_json().

## ◆ value

struct pm_node* pm_instance_variable_write_node::value

InstanceVariableWriteNode::value.

The value to write to the instance variable. It can be any non-void expression.

    @foo = :bar
           ^^^^

    @_x = 1234
          ^^^^

Definition at line 5181 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

The documentation for this struct was generated from the following file:

- prism/ast.h